From urlichs@smurf.sub.org  Tue Feb 19 06:20:35 1991
Received: from ira.uka.de (iraun1.ira.uka.de) by devvax.Jpl.Nasa.Gov (5.61/4.7)
	id AA26010; Tue, 19 Feb 91 06:20:35 -0800
Received: from smurf.sub.org by iraun1.uka.uucp id aa12881; 19 Feb 91 15:19 MET
Subject: Perl 4.0 problems +Patch
To: lwall@jpl-devvax.jpl.nasa.gov
Date: Tue, 19 Feb 91 12:26:18 MET
X-Mailer: ELM [version 2.3 PL6]
From: urlichs@smurf.sub.org (Matthias Urlichs)
Sender: urlichs@smurf.sub.org
Message-Id:  <9102191226.aa21110@smurf.smurf.sub.org>
Status: OR

Re Perl 4.0 beta:

- The program to decide about sys/file or fcntl needs a
  #include <sys/types.h>
  on some machines. At least on this machine, it also needs $cppflags for
  POSIX compatibility.
  Likewise, you auto-use -lbsd but don't use -lposix.
  You might want to reverse that if you see POSIX in the cppdefines
  anywhere.

- Patches follow to use the gdbm functions if they are present.
  You'll have to do the Configure part yourself (mainly because I couldn't
  find a clean way to integrate the additional test for gdbm into the
  $thislibrary/$thatlibrary stuff. Besides, I don't have metaconfig).
  Whether to special-case some of the functions in the source or to use
  #define's seems debatable; however, there may be conflicts with some
  libraries which alias these the other way so I hardcoded the differences
  into hash.c.
  You might want the error handling function (last argument to gdbm_open)
  to point to something which puts out an error message and dies; it wants
  (void)(*fn(int)). This mostly happens when dbm files run out of disk
  space.
  The test in t/op/dbm.t may fail because the file name extensions may
  not be what Perl expects. (My gdbm library doesn't append any extension;
  others append .dbm or .gdbm. I guess that's )

- Also in these patches is one instance of ushort, instead of ushort_t,
  in doio.c, which fails to compile when POSIX is defined.
  I have included a patch; you might have to special-case it with #ifdef
  _POSIX_SOURCE or something like that.

- The code to figure out the type of the signal handler is not complicated
  enough. Some systems have
  #ifdef _POSIX_SOURCE
  typedef void (*sigfunc_t)();
  #else
  typedef int (*sigfunc_t)();
  #endif
  somewhere in signal.h or sys/signal.h (which gets included by signal.h),
  and define signal in terms of sigfunc_t:
  extern sigfunc_t signal();
  So it seems that you'll have to grep for both signal and sigfunc.

- makedepend said:
  hash.c.c (/new/usr.local/src/perl.4/hash.c.c): 84: strEQ: argument mismatch
  util.c.c (/new/usr.local/src/perl.4/util.c.c): 95: New: argument mismatch
  Probably unimportant, but still...

Other than that, no problems; all tests test successfully.
NB: This is on a Mac running A/UX 2.0 with gcc and
-fpcc-struct-return -fomit-frame-pointer -fstrength-reduce -D_POSIX_SOURCE,
the middle two of which make "make test" about 5% faster.

*** doio.c.orig	Tue Feb 19 09:25:14 1991
--- doio.c	Tue Feb 19 09:25:46 1991
***************
*** 2504,2510 ****
  	    if (semctl(id, 0, IPC_STAT, &semds) == -1)
  		return -1;
  	    getinfo = (cmd == GETALL);
! 	    infosize = semds.sem_nsems * sizeof(ushort);
  	}
  	break;
  #endif
--- 2504,2510 ----
  	    if (semctl(id, 0, IPC_STAT, &semds) == -1)
  		return -1;
  	    getinfo = (cmd == GETALL);
! 	    infosize = semds.sem_nsems * sizeof(ushort_t);
  	}
  	break;
  #endif
*** hash.c.orig	Tue Feb 19 09:39:01 1991
--- hash.c	Tue Feb 19 10:53:33 1991
***************
*** 111,117 ****
--- 111,121 ----
      if (tb->tbl_dbm) {
  	dkey.dptr = key;
  	dkey.dsize = klen;
+ #ifdef HAS_GDBM
+ 	dcontent = gdbm_fetch(tb->tbl_dbm,dkey);
+ #else
  	dcontent = dbm_fetch(tb->tbl_dbm,dkey);
+ #endif
  	if (dcontent.dptr) {			/* found one */
  	    str = Str_new(60,dcontent.dsize);
  	    str_nset(str,dcontent.dptr,dcontent.dsize);
***************
*** 269,275 ****
--- 273,283 ----
  	if (tb->tbl_dbm) {
  	    dkey.dptr = key;
  	    dkey.dsize = klen;
+ #ifdef HAS_GDBM
+ 	    gdbm_delete(tb->tbl_dbm,dkey);
+ #else
  	    dbm_delete(tb->tbl_dbm,dkey);
+ #endif
  	}
  #endif
  	return str;
***************
*** 392,410 ****
  #ifdef SOME_DBM
      datum dkey;
      datum nextdkey;
  #ifdef HAS_NDBM
      DBM *old_dbm;
  #else
      int old_dbm;
  #endif
  #endif
  
      if (!tb || !tb->tbl_array)
  	return;
  #ifdef SOME_DBM
      if ((old_dbm = tb->tbl_dbm) && dodbm) {
  	while (dkey = dbm_firstkey(tb->tbl_dbm), dkey.dptr) {
  	    do {
  #ifdef HAS_NDBM
  #ifdef _CX_UX
  		nextdkey = dbm_nextkey(tb->tbl_dbm, dkey);
--- 400,429 ----
  #ifdef SOME_DBM
      datum dkey;
      datum nextdkey;
! #ifdef HAS_GDBM
!     GDBM_FILE old_dbm;
! #else
  #ifdef HAS_NDBM
      DBM *old_dbm;
  #else
      int old_dbm;
  #endif
  #endif
+ #endif
  
      if (!tb || !tb->tbl_array)
  	return;
  #ifdef SOME_DBM
      if ((old_dbm = tb->tbl_dbm) && dodbm) {
+ #ifdef HAS_GDBM
+ 	while (dkey = gdbm_firstkey(tb->tbl_dbm), dkey.dptr) {
+ #else
  	while (dkey = dbm_firstkey(tb->tbl_dbm), dkey.dptr) {
+ #endif
  	    do {
+ #ifdef HAS_GDBM
+ 		nextdkey = gdbm_nextkey(tb->tbl_dbm, dkey);
+ #else
  #ifdef HAS_NDBM
  #ifdef _CX_UX
  		nextdkey = dbm_nextkey(tb->tbl_dbm, dkey);
***************
*** 414,420 ****
--- 433,444 ----
  #else
  		nextdkey = nextkey(dkey);
  #endif
+ #endif
+ #ifdef HAS_GDBM
+ 		gdbm_delete(tb->tbl_dbm,dkey);
+ #else
  		dbm_delete(tb->tbl_dbm,dkey);
+ #endif
  		dkey = nextdkey;
  	    } while (dkey.dptr);	/* one way or another, this works */
  	}
***************
*** 466,471 ****
--- 490,500 ----
  #ifdef SOME_DBM
      if (tb->tbl_dbm) {
  	if (entry) {
+ #ifdef HAS_GDBM
+ 	    key.dptr = entry->hent_key;
+ 	    key.dsize = entry->hent_klen;
+ 	    key = gdbm_nextkey(tb->tbl_dbm, key);
+ #else
  #ifdef HAS_NDBM
  #ifdef _CX_UX
  	    key.dptr = entry->hent_key;
***************
*** 479,489 ****
--- 508,523 ----
  	    key.dsize = entry->hent_klen;
  	    key = nextkey(key);
  #endif
+ #endif
  	}
  	else {
  	    Newz(504,entry, 1, HENT);
  	    tb->tbl_eiter = entry;
+ #ifdef HAS_GDBM
+ 	    key = gdbm_firstkey(tb->tbl_dbm);
+ #else
  	    key = dbm_firstkey(tb->tbl_dbm);
+ #endif
  	}
  	entry->hent_key = key.dptr;
  	entry->hent_klen = key.dsize;
***************
*** 536,542 ****
--- 570,580 ----
      if (tb->tbl_dbm) {
  	key.dptr = entry->hent_key;
  	key.dsize = entry->hent_klen;
+ #ifdef HAS_GDBM
+ 	content = gdbm_fetch(tb->tbl_dbm,key);
+ #else
  	content = dbm_fetch(tb->tbl_dbm,key);
+ #endif
  	if (!entry->hent_val)
  	    entry->hent_val = Str_new(62,0);
  	str_nset(entry->hent_val,content.dptr,content.dsize);
***************
*** 566,572 ****
  #define O_CREAT 01000
  #endif
  
! #ifndef HAS_NDBM
  static int dbmrefcnt = 0;
  #endif
  
--- 604,610 ----
  #define O_CREAT 01000
  #endif
  
! #ifdef HAS_ODBM
  static int dbmrefcnt = 0;
  #endif
  
***************
*** 578,584 ****
  {
      if (!tb)
  	return FALSE;
! #ifndef HAS_NDBM
      if (tb->tbl_dbm)	/* never really closed it */
  	return TRUE;
  #endif
--- 616,622 ----
  {
      if (!tb)
  	return FALSE;
! #ifdef HAS_ODBM
      if (tb->tbl_dbm)	/* never really closed it */
  	return TRUE;
  #endif
***************
*** 587,592 ****
--- 625,638 ----
  	tb->tbl_dbm = 0;
      }
      hclear(tb, FALSE);	/* clear cache */
+ #ifdef HAS_GDBM
+     if (mode >= 0)
+ 	tb->tbl_dbm = gdbm_open(fname, 0, GDBM_WRCREAT,mode, (void *) NULL);
+     if (!tb->tbl_dbm)
+ 	tb->tbl_dbm = gdbm_open(fname, 0, GDBM_WRITER, mode, (void *) NULL);
+     if (!tb->tbl_dbm)
+ 	tb->tbl_dbm = gdbm_open(fname, 0, GDBM_READER, mode, (void *) NULL);
+ #else
  #ifdef HAS_NDBM
      if (mode >= 0)
  	tb->tbl_dbm = dbm_open(fname, O_RDWR|O_CREAT, mode);
***************
*** 607,612 ****
--- 653,659 ----
      }
      tb->tbl_dbm = dbminit(fname) >= 0;
  #endif
+ #endif
      if (!tb->tbl_array && tb->tbl_dbm != 0)
  	Newz(507,tb->tbl_array, tb->tbl_max + 1, HENT*);
      return tb->tbl_dbm != 0;
***************
*** 617,622 ****
--- 664,673 ----
  register HASH *tb;
  {
      if (tb && tb->tbl_dbm) {
+ #ifdef HAS_GDBM
+ 	gdbm_close(tb->tbl_dbm);
+ 	tb->tbl_dbm = 0;
+ #else
  #ifdef HAS_NDBM
  	dbm_close(tb->tbl_dbm);
  	tb->tbl_dbm = 0;
***************
*** 623,628 ****
--- 674,680 ----
  #else
  	/* dbmrefcnt--;  */	/* doesn't work, rats */
  #endif
+ #endif
      }
      else if (dowarn)
  	warn("Close on unopened dbm file");
***************
*** 644,650 ****
--- 696,706 ----
      dkey.dsize = klen;
      dcontent.dptr = str_get(str);
      dcontent.dsize = str->str_cur;
+ #ifdef HAS_GDBM
+     error = gdbm_store(tb->tbl_dbm, dkey, dcontent, GDBM_REPLACE);
+ #else
      error = dbm_store(tb->tbl_dbm, dkey, dcontent, DBM_REPLACE);
+ #endif
      if (error) {
  	if (errno == EPERM)
  	    fatal("No write permission to dbm file");
*** hash.h.orig	Tue Feb 19 09:34:54 1991
--- hash.h	Tue Feb 19 10:07:44 1991
***************
*** 43,52 ****
--- 43,56 ----
      SPAT 	*tbl_spatroot;	/* list of spats for this package */
      char	*tbl_name;	/* name, if a symbol table */
  #ifdef SOME_DBM
+ #ifdef HAS_GDBM
+     GDBM_FILE	tbl_dbm;
+ #else
  #ifdef HAS_NDBM
      DBM		*tbl_dbm;
  #else
      int		tbl_dbm;
+ #endif
  #endif
  #endif
      unsigned char tbl_coeffsize;	/* is 0 for symbol tables */
*** perl.h.orig	Fri Feb 15 20:13:36 1991
--- perl.h	Tue Feb 19 09:34:37 1991
***************
*** 235,240 ****
--- 235,250 ----
  #endif
  #endif
  
+ #ifdef HAS_GDBM
+ #include <gdbm.h>
+ #define SOME_DBM
+ #ifdef HAS_NDBM
+ #undef HAS_NDBM
+ #endif
+ #ifdef HAS_ODBM
+ #undef HAS_ODBM
+ #endif
+ #else
  #ifdef HAS_NDBM
  #include <ndbm.h>
  #define SOME_DBM
***************
*** 259,264 ****
--- 269,275 ----
  #define dbm_firstkey(db) firstkey()
  #endif /* HAS_ODBM */
  #endif /* HAS_NDBM */
+ #endif /* HAS_GDBM */
  #ifdef SOME_DBM
  EXT char *dbmkey;
  EXT int dbmlen;
*** config_h.SH.orig	Tue Feb 19 11:19:41 1991
--- config_h.SH	Tue Feb 19 08:52:03 1991
***************
*** 310,315 ****
--- 310,321 ----
   */
  #$d_msgsnd	HAS_MSGSND		/**/
  
+ /* HAS_GDBM
+  *	This symbol, if defined, indicates that gdbm.h exists and should
+  *	be included.
+  */
+ #$d_gdbm	HAS_GDBM		/**/
+ 
  /* HAS_NDBM
   *	This symbol, if defined, indicates that ndbm.h exists and should
   *	be included.
-- 
Matthias Urlichs -- urlichs@smurf.sub.org -- urlichs@smurf.ira.uka.de     /(o\
Humboldtstrasse 7 - 7500 Karlsruhe 1 - FRG -- +49+721+621127(0700-2330)   \o)/
[Vacation]


